#!/usr/bin/env bash
# https://betterdev.blog/minimal-safe-bash-script-template/
# After you copy it, you only need to change 4 things:
    # usage() text with script description
    # cleanup() content
    # parameters in parse_params() – leave the --help and --no-color, but replace the example ones: -f and -p
    # actual script logic

set -Eeuo pipefail
trap cleanup SIGINT SIGTERM ERR EXIT

script_dir=$(cd "$(dirname "${BASH_SOURCE[0]}")" &>/dev/null && pwd -P)

usage() {
  cat <<EOF
Usage: $(basename "${BASH_SOURCE[0]}") [-h] [-v] [-f] -p param_value arg1 [arg2...]

Backup vm to PBS

Available options:

-h, --help      Print this help and exit
-v, --verbose   Print script debug info
-e, --exclude   Exclude files and folders
-i, --include   Include files and folders

EOF
  exit
}

cleanup() {
  trap - SIGINT SIGTERM ERR EXIT
  # script cleanup here
}

setup_colors() {
  if [[ -t 2 ]] && [[ -z "${NO_COLOR-}" ]] && [[ "${TERM-}" != "dumb" ]]; then
    NOFORMAT='\033[0m' RED='\033[0;31m' GREEN='\033[0;32m' ORANGE='\033[0;33m' BLUE='\033[0;34m' PURPLE='\033[0;35m' CYAN='\033[0;36m' YELLOW='\033[1;33m'
  else
    NOFORMAT='' RED='' GREEN='' ORANGE='' BLUE='' PURPLE='' CYAN='' YELLOW=''
  fi
}

msg() {
  echo >&2 -e "${1-}"
}

die() {
  local msg=$1
  local code=${2-1} # default exit status 1
  msg "$msg"
  exit "$code"
}

parse_params() {
  # default values of variables set from params
  #flag=0
  #param=''

  while :; do
    case "${1-}" in
    -h | --help) usage ;;
    -v | --verbose) set -x ;;
    --no-color) NO_COLOR=1 ;;
    -e | --exclude) 
      EXCLUDE="${2-}"
      shift
      ;;
    -i | --include) 
      INCLUDE="${3-}"
      shift
      ;;
    -?*) die "Unknown option: $1" ;;
    *) break ;;
    esac
    shift
  done

  args=("$@")

  # check required params and arguments
  [[ -z "${INCLUDE-}" ]] && die "Missing required parameter: param"
  [[ -z "${EXCLUDE-}" ]] && die "Missing required parameter: param"
  [[ ${#args[@]} -eq 0 ]] && die "Missing script arguments"

  return 0
}

parse_params "$@"
setup_colors

echo "EXCLUDE=$EXCLUDE and INCLUDE=$INCLUDE"

# export PBS_REPOSITORY=bck_ops@pbs@vmx-pbs.tail:kut-backup
# export PBS_PASSWORD=Wiry3-Finally-Juror-Glorious
# export PBS_FINGERPRINT="58:0d:62:d1:64:18:8a:7b:fd:56:71:45:47:28:53:a3:dc:9e:b5:74:4b:d2:f3:1f:56:6c:14:d5:98:13:43:40"
# apt clean cache
# HC_ID=$1
# EXCLUDE=$2

# proxmox-backup-client backup root.pxar:/ --exclude "$EXCLUDE" && curl -m 10 --retry 5 https://hc.noxs.me/ping/"$HC_ID"

msg "${RED}Read parameters:${NOFORMAT}"
msg "- flag: ${flag}"
msg "- param: ${param}"
msg "- arguments: ${args[*]-}"
